#include <PWM.h> // "PWM_Frequency_lbrary" to simplify the PWM-Adjustment and Output
#include <EasyTransfer.h> // 

EasyTransfer ET; // create object

int ledPin = 9; // D9 (PWM)Output

// ET:
struct RECEIVE_DATA_STRUCTURE {
//put your variable definitions here for the data you want to send
//THIS MUST BE EXACTLY THE SAME ON THE OTHER ARDUINO
  int a_value;
};
//give a name to the group of data
RECEIVE_DATA_STRUCTURE mydata;

// PWM:
int32_t frequency = 20000; //frequency (in Hz)

void setup() {
  pinMode(9, OUTPUT);   // PWM-Output to Power-LED

  // PWM: initialize all timers except for 0, to save time-keeping functions
  InitTimersSafe(); // Timer-1 => D9(=PB1,Pin-13) and D10(=PB2,Pin-14);  Timer-2 => D3(=PD3,Pin-1) and D11(=PB3,Pin-15);  excluded Timer-0 => D5 and D6

  pinMode(13, INPUT); // PWM-Input (from D9) to D13 (Arduino-LED in high-impedance/input mode)
  
  // sets the (PWM)frequency for the specified pin (ledPin, D3)
  SetPinFrequencySafe(ledPin, frequency);

  Serial.begin(4800); // the baudrate (both "modems" must have equal baudrates to synchronize!)
  //start the ET-library, pass in the data details and the name of the serial port. Can be Serial, Serial1, Serial2, etc. 
  ET.begin(details(mydata), &Serial);
}

void loop() {
  //check and see if a data packet has come in. 
  if(ET.receiveData()) {
    //this is how you access the variables. [name of the group].[variable name]
    //since we have data, we will write it out. 
    mydata.a_value;
  }
  pwmWrite(ledPin,mydata.a_value/4); // write "PWM" to D9 => (0 - 1023 max) / 4 = 0 - 255 (value)

// you should make this delay shorter then your transmit delay or else messages could be lost
   delay(20);			// a small 10ms-delay per loop
}
// --------------------------------eof---------------------------------
